% script of the function to uncompress t2 file to a Nx2 matrix. First colume is timing and second column is bitvalue. 

function t2tab = func_uncompresst2 (t2basedir, readepoch) % define the function to read an epoch from the source dir
t2file = fopen(strcat(t2basedir,readepoch));
data = fread(t2file,'uint32'); % read an epoch
fclose(t2file);                  

length = data(3);             % so many clicks in the epoch
timeorder = data(4);        % each timing extract from so many bits
basebits = data(5); 
t2tab = zeros(length,2);  % initialize a matrix to store the result
i=0;                               % point to the click being processed. It also pointed to the element to be stored in t2tab.
restbitsnum = 32;           % buffer length. so many bits left need to be read in the buffer.
restbits = data(7);           % integer value of the bits left to be read in the buffer. data(7) is the first interger filled into the buffer.
ii=7;                               % pointer to the integer being read

while (i<length)               % process stops until all clicks finished
    % read the timing. If the buffer is not long enough, concatenate the next integer
    if (restbitsnum>=timeorder) 
        tim = fix( restbits / 2^(restbitsnum-timeorder) );
        restbits = mod( restbits, 2^(restbitsnum-timeorder) );
        restbitsnum = restbitsnum -timeorder;
    else
        ii=ii+1;
        tim = restbits*2^(timeorder-restbitsnum)+ fix( data(ii) / 2^(32+restbitsnum-timeorder) );   
        restbits = mod ( data(ii), 2^(32+restbitsnum-timeorder) );               
        restbitsnum = restbitsnum + 32-timeorder;
    end
  
    if (tim == 0) % if tim==0, read the next 32 bits as the timing
        ii=ii+1;
        tim = restbits*2^(32-restbitsnum)+ fix( data(ii) / 2^restbitsnum );   %read the 32-bit timing
        restbits = mod ( data(ii), 2^restbitsnum );      
        if (restbitsnum>=basebits)       
            res = fix( restbits / 2^(restbitsnum-basebits) );   % read the detector bit value
            restbits = mod( restbits, 2^(restbitsnum-basebits) );      
            restbitsnum = restbitsnum -basebits;    
        else            
            ii=ii+1;
            res = restbits*2^(basebits-restbitsnum)+ fix( data(ii) / 2^(32+restbitsnum-basebits) );           
            restbits = mod ( data(ii), 2^(32+restbitsnum-basebits) );                       
            restbitsnum = restbitsnum + 32-basebits;   
        end
        i = i + 1;           
        t2tab(i,1) = tim;            
        t2tab(i,2) = res;
    elseif (tim > 1)   %if tim>1, this is the timing        
        if (restbitsnum>=basebits)       
            res = fix( restbits / 2^(restbitsnum-basebits) );      
            restbits = mod( restbits, 2^(restbitsnum-basebits) );      
            restbitsnum = restbitsnum -basebits;    
        else            
            ii=ii+1;
            res = restbits*2^(basebits-restbitsnum)+ fix( data(ii) / 2^(32+restbitsnum-basebits) );           
            restbits = mod ( data(ii), 2^(32+restbitsnum-basebits) );                       
            restbitsnum = restbitsnum + 32-basebits;   
        end
        i = i + 1;           
        t2tab(i,1) = tim;            
        t2tab(i,2) = res;
    end
    
end

end