% script of the function to uncompress t4 file to an arrary

function t4tab = func_uncompresst4 (t4basedir, readepoch)
t4file = fopen(strcat(t4basedir,readepoch));
data = fread(t4file,'uint32'); % read an epoch
fclose(t4file);                  

length = data(3);             % so many clicks in the epoch
timeorder = data(4);        % each timing extract from so many bits
basebits = data(5); 
t4tab = zeros(length,1);  % initialize an array to store the result

i=0;                               % point to the click being processed. It also pointed to the element to be stored in t4tab.
restbitsnum = 32;           % buffer length. so many bits left need to be read in the buffer.
restbits = data(6);           % integer value of the bits left to be read in the buffer. data(7) is the first interger filled into the buffer.
ii=6;                               % pointer to the integer being read

while (i<length)               % process stops until all clicks finished
    % read the timing. If the buffer is not long enough, concatenate the next integer
    if (restbitsnum>=timeorder) 
        tim = fix( restbits / 2^(restbitsnum-timeorder) );
        restbits = mod( restbits, 2^(restbitsnum-timeorder) );
        restbitsnum = restbitsnum -timeorder;
    else
        ii=ii+1;
        tim = restbits*2^(timeorder-restbitsnum)+ fix( data(ii) / 2^(32+restbitsnum-timeorder) );   
        restbits = mod ( data(ii), 2^(32+restbitsnum-timeorder) );               
        restbitsnum = restbitsnum + 32-timeorder;
    end
  
    if (tim == 0) % if tim==0, read the next 32 bits as the timing
        ii=ii+1;
        tim = restbits*2^(32-restbitsnum)+ fix( data(ii) / 2^restbitsnum );   %read the 32-bit timing
        restbits = mod ( data(ii), 2^restbitsnum );      
    end
    
    i = i + 1;    
    t4tab(i,1) = tim-2;                
end

end